function R1 = backward_solve(A1)

m = size(A1,1);

n = size(A1,2);

c = m*n;

B = zeros(c,c);

for i = 1:c

	for j= 1:c

		k1=(i-1-mod(i-1,n))/n;

		k2=(1+mod(i-1,n));

		l1=(j-1-mod(j-1,n))/n;

		l2=(1+mod(j-1,n));

		if(((abs(k1-l1)==0)&&(abs(k2-l2)==1))||((abs(k1-l1)==1)&&(abs(k2-l2)==0))) 

			B(i,j) = 1;

		end

		if((k1==l1)&&(k2==l2))

			B(i,j) = 1;

		end

	end

end

R = zeros(1,c);

A = zeros(1,c);

for i = 1:m

	for j=1:n

		A(1,(((i-1)*n)+j)) = A1(i,j); 

	end

end

R = (A*(B^(-1))).*det(B);

R = abs(R);

R = int64(R);

R = mod(R,2);

R1 = zeros(m,n);

for i = 1:m

	for j=1:n

		 R1(i,j) = R(1,(((i-1)*n)+j)); 

	end

end

return 

endfunction



